(* recherche de processus cach pour noyau 2.4
   Ecrit en Dcembre 2003, license GPL
   Franois Boisson, francois@boisson.homeip.net *)

#open "sys";;
#open "unix";;
#open "format";;
chdir "/proc";;
(* test si le fichier f existe *)
let test_fichier f =
try ((close_in (open_in f));true) with
_ -> false;;

let bouffe _ = ();;

(* boolen "noyau = 2.6" *)
let nouveau_noyau = test_fichier "1/task";;

(* liste des fichiers du repertoire s *)
let liste_repertoire s =
	 let c = (opendir s)
  in
  let res = ref [] in
  let rec boucle () =
      try (res:=(readdir c)::!res;boucle ()) with _-> ((closedir c);!res)
      in boucle ();;

(* s commence par un chiffre *)
let selection s = let c= int_of_char s.[0] in (c >= 48) && (c <= 57);;

(* liste des pids visibles *)
let liste_totale () = 
if nouveau_noyau then (flat_map 
     (function s ->
	      if (selection s) then
		if (test_fichier (s^"/task")) then 
		  (let liste = (liste_repertoire (s^"/task")) in
		      if (mem s liste) then liste else s::liste)
		else [s]
              else [])
		       (liste_repertoire "."))
else liste_repertoire ".";;


(* Truc beau  la Loick *)
let curseur = ref 0;;


let tableau = [|"|"; "/"; "-"; "\\"; "|"|];;

let beau () = 
    print_string (
    (tableau.((curseur:=((succ !curseur) mod 4);!curseur)))^"\b");
    print_flush ();;

(*
let beau N  =
    print_string  (string_of_int ((!curseur / N) mod 10));
    curseur:=(succ !curseur) mod (10*N);
    if (!curseur mod N = 0) then print_string "\r";
    print_flush ();;
*)

(* un choua mgalo *)
print_string "Recherche de processus cachs F.Boisson Dec2003";;
print_newline ();;


(* bazar *)
let total = ref 0 in
(
print_string "...";
for i = 1 to 65535 do
  let si = (string_of_int i) in
      if ((test_fichier si) && (beau (); not mem si (liste_totale ()))) then (

	total := !total +1;
	print_string "Processus cach :";
	print_int i;
	print_newline ();

	

	print_string "Ligne de commande:\n";
	print_newline ();
	if nouveau_noyau
	then
	  if (test_fichier ("./"^si^"/task/"^si^"/cmdline"))
	  then bouffe (system_command ("cat ./"^si^"/task/"^si^"/cmdline"))
	  else print_string "Pas de fichier cmdline"
	else (
	  try (bouffe (system_command ("cat ./"^si^"/cmdline")))
	  with _ -> ());
	print_newline ();
	print_string "Environnement:\n";
	print_newline ();
	if nouveau_noyau then
	  if (test_fichier ("./"^si^"/task/"^si^"/environ"))
	  then bouffe (system_command ("cat ./"^si^"/task/"^si^"/environ"))
	  else print_string "Pas de fichier environ" 
	else (
	    try (bouffe (system_command ("cat ./"^si^"/environ")))
	    with _ -> ());
	print_newline ();
	print_newline ();
      );
done;
    
    print_newline ();
    print_int !total;
    print_string " processus cach(s) trouv(s)";
    print_newline ();
    );;
